﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Activity
Version=9.5
@EndOfDesignText@
#Region  Activity Attributes 
	#FullScreen: False
	#IncludeTitle: False
#End Region

Sub Process_Globals
	'These global variables will be declared once when the application starts.
	'These variables can be accessed from all modules.
	Public setup_power_layout As Boolean=False
	Public Action_Command As Boolean=False
	Public actif_save As Boolean=False
	Public Update_data_sensor_enable As Boolean=False
	Public test_device As Boolean=False
	Public Type_power As Int 
	Public const HS110 As Int=0
	Public const Beewi As Int=1
	Public const Thermo As Int=2
	 
	
End Sub

Sub Globals
	'These global variables will be redeclared each time the activity is created.
	'These variables can only be accessed from this module.
	Dim cs As CSBuilder
	Private Button_search_power As B4XView
	Private Label_name_sensor As B4XView
	
	Private Rdb_Bluetooth As B4XView
	Private Rdb_wifi As B4XView
	Private Lbl_type_connexion As B4XView
	Private Lbl_graph_battery As B4XView
	Dim Graph_MinValue As Int=0
	Dim Graph_MaxValue As Int=0
	Dim Graph_width As Int=0
	Private C_temp As String=""
	
	Private Niv_bat As B4XView
	Private Panel_sensor As B4XView
	Private Btn_modif_sensor As B4XView
	Private Btn_save_sensor As B4XView
	Private Lbl_Temp As B4XView
	Private Lbl_alerte_bat As B4XView
	Private Txt_Local_sensor As B4XView
	Private SeekBar_Temp_cons As B4XView
	Private file_Setup = ""
	Dim confirme_retour As Int
	Private Remove_Sensor As Boolean=False
	Private Xui As XUI
	
	Private Btn_trash As B4XView
	Private RadioButton1 As B4XView
	Private Rdb_thermo As B4XView
	
	Private Lbl_add_equip As B4XView
	Private Panel_power As B4XView

	
	Private Lbl_info_power As B4XView
	
	
	Private Lbl_lock_power As B4XView
	Private cbxWifiAdv As B4XView
	Private etWifiPwd As B4XView
	Private lblWifiSec As B4XView
	Private lblWifiSig As B4XView
	Private Lbl_info As B4XView
	Private StrUtil As StringFunctions
	
	Private ProgressBar1 As B4XView
	Private Btn_conso As B4XView
	
	Private Btn_off As B4XView
	Private Btn_on As B4XView
	Private Btn_quit As B4XView
	Private Lbl_mA As B4XView
	Private Lbl_volt As B4XView
	Private Lbl_Watt As B4XView
	Private Pnl_test_conso As B4XView
	Private Btn_restart As B4XView
	Private myWifi As MLwifi
	Private Test_OnOff As Boolean=False
	Private stop_Ping As Boolean=False
	Private Paired As Boolean=False
	Private Save_Power_Param As Boolean=False
	Private Ip_Tplink As String=""
	Private Pnl_equipement As B4XView
	Private Pnl_power As B4XView
	Private Lbl_statut_power As B4XView
	Private Lbl_power_alert As B4XView
	
	Private ImageSlider1 As ImageSlider
	Private Lbl_valid_power As B4XView
	Private Pnl_tools_power As B4XView
	Private Lbl_type_cx As B4XView
	
End Sub

Sub Activity_Create(FirstTime As Boolean)
	
	Activity.LoadLayout("Setup_sensor")
	StrUtil.Initialize
	ImageSlider1.NumberOfImages=3
	Lbl_type_cx.Visible=False
		
	file_Setup=Main.Localisation_Home & "_" & "setup.txt"
	
	' Calibration de l'indicateur de niveau de batterie
	'dim batterie
	Graph_MinValue = Lbl_graph_battery.Left
	Graph_MaxValue= Lbl_graph_battery.Left + Lbl_graph_battery.Width - Niv_bat.Width
	Dim ratio As Int= (Graph_MaxValue-Graph_MinValue)/50
	
	' Recherche dans le setup le sensor et vérifie si des éléments on changés. Si c'est le cas, indique "Mise à jour en cours"
	Dim find_sensor As Boolean=False
	
	For Each data As String In Main.list_Read_Setup
		Dim data_setup() As String =Regex.Split(";", data)
		
		
			If data_setup(2)=Cockpit.Macaddress Then 'identifie le sensor concerné
				If data_setup.Length>=4 Then
					find_sensor=True
					
					'Définition level Battery de 50% = mini et 100%=Max
					'Cockpit.level_battery=50
					If Cockpit.level_battery<=50 Then
						Lbl_alerte_bat.Visible=True
						Lbl_alerte_bat.Text=Cockpit.level_battery & "%"
						Niv_bat.left=Graph_MinValue
					Else if Cockpit.level_battery>50 Then
						Lbl_alerte_bat.Visible=False
						Niv_bat.left=(Cockpit.level_battery-50)*ratio + Graph_MinValue
					End If
		
					If Cockpit.Local_sensor<>data_setup(1) Or Cockpit.T_consigne<> data_setup(3) Then
						Xui.MsgboxAsync("Une mise à jour est en cours","Information Sensor")
					End If
					Txt_Local_sensor.Text= data_setup(1)
					SeekBar_Temp_cons.Progress= data_setup(3)
					C_temp=data_setup(3)
					SeekBar_Temp_cons.Enabled=False
					Txt_Local_sensor.Enabled=False
					
					' Verifie si une prise est associée et l'affiche
					If data_setup.Length = 7 Then
						Pnl_equipement.Visible=False
						Pnl_power.Visible=True
					Else
						Pnl_equipement.Visible=True
						Pnl_power.Visible=False
					End If 
					
				Else
					Activity.Finish
				End If
			End If
		
		
	Next

	If find_sensor=False Then 'Si le Sensor n'existe plus , on sort de la configuration
		Xui.MsgboxAsync("Le sensor a été supprimé. Mise à jour en cours","Information Sensor")
		Activity.Finish
	End If
	
	
	
End Sub

Sub Activity_KeyPress (KeyCode As Int) As Boolean 'return true if you want to consume the event
    
	
	
	Select KeyCode
		Case KeyCodes.KEYCODE_VOLUME_UP
			Log("Up")
			Return True
					
		Case KeyCodes.KEYCODE_VOLUME_DOWN
			Log("Down")
			Return True
		Case KeyCodes.KEYCODE_BACK
			
			If actif_save=False And Action_Command=False Then
				Return False
			Else
				
				ToastMessageShow("Veuillez patienter...",True)
				Return True
			End If
		
	End Select
End Sub

Sub Activity_Resume
	setup_power_layout=True
End Sub

Sub Activity_Pause (UserClosed As Boolean)
	
	setup_power_layout=False
	StopService(Scan_Power)
	StopService(TPL_Echange)
End Sub

Public Sub SetState
	Lbl_lock_power.Visible = TPL_Echange.connected
	
End Sub

public Sub SetState_Answer_data
	
	Dim voltage As Double
	Dim Current_ma As Double
	Dim Power_mw As Double
	
	Dim trame As JSONParser
	Dim Map1 As Map
	
	Lbl_info_power.TextSize=15
	Lbl_info.SetTextAlignment("TOP","LEFT")
	
	If  test_device=False Then
		If TPL_Echange.Answer_Data=True Then
			Lbl_info.Text="Vérifiez la Led sur votre prise." & Chr(13) & "Elle devrait clignoter en vert quelques secondes, puis restée fixe." _
		 & Chr(13) & "Dans le cas contraire, relancez le scan."
			CallSubDelayed(Scan_Power,"scan")
		Else
			Lbl_info.Text="Echec de configuration !" & Chr(13) & "Veuillez relancer le scan."
		End If
		
	Else 
		'resultat Test conso device
		Try
			If TPL_Echange.Answer_Data=True And Test_OnOff=False Then
				
				
				trame.Initialize(TPL_Echange.Response_Data_Device)
				Map1=trame.NextObject
				Dim m As Map 'helper map for navigating
				m = Map1.Get("emeter")
				m= m.Get("get_realtime")
				Try
					voltage=m.Get("voltage_mv")
					Current_ma= m.Get("current_ma")
					Power_mw= m.Get("power_mw")
					voltage=voltage/1000
					Power_mw=Power_mw/1000
				Catch
					voltage=m.Get("voltage")
					Current_ma= m.Get("current")
					Power_mw= m.Get("power")
				End Try
				
				
				'Dim data_split1() As String
				'Dim data_split() As String= Regex.Split(",",TPL_Echange.Response_Data_Device)
			
'				If data_split(0).Contains("get_realtime")=True Then 'Identifie la trame de conso
'					data_split1= Regex.Split(":",data_split(0))
'					voltage  = data_split1(3)
'					data_split1= Regex.Split(":",data_split(1))
'					Current_ma=data_split1(1)
'					data_split1= Regex.Split(":",data_split(2))
'					Power_mw= data_split1(1)
'				End If
				'voltage=voltage/1000
				'Power_mw=Power_mw/1000
				Lbl_volt.Text=Round2(voltage,2)
				Lbl_mA.Text=Round2(Current_ma,1)
				Lbl_Watt.Text=Round2(Power_mw,1)
				
				
				If test_device=True Then
					Scan_Power.sending_data=False
					
					Sleep(2000)
					test_conso_device 'Relance la mesure au bout de 2 secondes
				End If
			Else 
				If Test_OnOff=True Then
					test_device=False
					Test_OnOff=False
					Btn_restart.Text= cs.Initialize.Typeface(Typeface.MATERIALICONS).Color(0xFF9C0000).Size(25).Append(Chr(0xE5D5)).PopAll
				Else
					Lbl_info.Text="La commande a échoué"
				End If
				
			End If
		Catch
			Lbl_info.Text="La commande a échoué"
		End Try
		
	End If
	
	
End Sub


Public Sub tryAdd(Ref_Network As String)
	Dim strSplit() As String = Regex.Split(",", Ref_Network)
	Dim iSignal As Int = strSplit(2).Trim
	Dim sSignal As String
	Dim login As String=strSplit(0)
	Dim wifiPasswd As String
	'Dim security As Int
	
	Dim dialog As CustomLayoutDialog
	Dim sf As Object = dialog.ShowAsync(strSplit(0), "Connect", "Cancel", "", Null, False)

	dialog.SetSize(100%x, 300dip)
	Wait For (sf) Dialog_Ready (DialogPanel As Panel)
	
	DialogPanel.LoadLayout("wifiDialog")

	If iSignal >= -30 Then
		sSignal = "Excellent"
	Else If strSplit(2).Trim >= -67 Then
		sSignal = "Very Good"
	Else If strSplit(2).Trim >= -70 Then
		sSignal = "Good"
	Else If strSplit(2).Trim >= -80 Then
		sSignal = "Bad"
	Else
		sSignal = "Very Bad"
	End If
	
	
	
	lblWifiSec.Text = strSplit(1)
	lblWifiSig.Text = sSignal
	
	Wait For (sf) Dialog_Result (Result As Int)
	
	wifiPasswd = etWifiPwd.Text
	etWifiPwd.Enabled = False


' Remplacement du & et de ' par le symbole decimal de TP-Link. Contournement bug TP-link

	If login.Contains("&") Then
		login=StrUtil.Stuff(login,"\u0026","&")
	End If
	
	If login.Contains("'") Then
		login=StrUtil.Stuff(login,"\u0027","&")
	End If
	
	
	If wifiPasswd.Contains("&") Then
		wifiPasswd= StrUtil.Stuff(wifiPasswd,"\u0026","&")
	End If
	
	If wifiPasswd.Contains("'") Then
		wifiPasswd= StrUtil.Stuff(wifiPasswd,"\u0027","&")
	End If
	
	
	If Result = -1 Then
		' Configuration de la requete wifi à transmetre (paramétrage de connexion au réseau local)
		 Scan_Power.Network= Chr(34) & "netif" & Chr(34)  & Chr(58) & Chr(123) & Chr(34) & "set_stainfo" & _
			 Chr(34) & Chr(58) & Chr(123) & Chr(34) & "key_type" & Chr(34) & Chr(58) & "3" & Chr(44) & Chr(34) & "password" & _
			  Chr(34) & Chr(58) & Chr(34) & wifiPasswd & Chr(34) & Chr(44) & Chr(34) & "ssid" & Chr(34) & Chr(58) & Chr(34) & login & _
			   Chr(34) & Chr(125) & Chr(125) & Chr(125)
			   
		' Appel Routine envoi de la trame sur le device
		
		CallSub2(TPL_Echange, "ConnectToServer",Scan_Power.ip) 'Connexion sur la prise
	End If
	
End Sub


Sub Button_search_power_Click
	Pnl_tools_power.Enabled=False
	Paired=False
	test_device=False
	Lbl_info.Text=""
		StopService(TPL_Echange)
	If Rdb_Bluetooth.Checked=False And Rdb_thermo.Checked=False And Rdb_wifi.Checked=False Then
		Xui.MsgboxAsync("Veuillez selectionner le type de prise","Information")
		
	Else if Lbl_info_power.Text="Recherche en cours..." Then
		Button_search_power.Text=cs.Initialize.Typeface(Typeface.MATERIALICONS).Color(0xFFFF0000).Size(38).Append(Chr(0xE8B6) ).PopAll
		StopService(Scan_Power)
		Lbl_info_power.Text=""
	Else
		Button_search_power.Text=cs.Initialize.Typeface(Typeface.MATERIALICONS).Color(0xFF56CDF1).Size(38).Append(Chr(0xE8B6)).PopAll
		Lbl_info_power.Text="Recherche en cours..."
		Lbl_info_power.Visible=True
		Lbl_info.Enabled=False
'		If Scan_Power.Network_Local<>"" Then
'			Scan_Power.WiFiConnect1.ConnectToSSID(0,Scan_Power.Network_Local,"") 'ReConnexion sur le réseau local
'		End If
		 
		StartService(Scan_Power)
		
	End If
	
	
End Sub

Sub refresh(device_name As String)
	
	If device_name="Prise configurée" Then
		Pnl_tools_power.Enabled=True
		Lbl_info.Enabled=True
		Lbl_info.TextSize=20
		Lbl_info.SetTextAlignment("CENTER","CENTER")
		Lbl_info.Text= "Appuyez ICI" & Chr(13) & Chr(10) & "pour tester la prise connectée."
		Lbl_info_power.Text=device_name
	Else
		Lbl_info_power.Text=device_name
	End If
	
	
End Sub

Sub Rdb_wifi_CheckedChange(Checked As Boolean)
	'Lbl_type_connexion.Text=cs.Initialize.Typeface(Typeface.MATERIALICONS).Color(0xFF01FF20).Size(40).Append(Chr(0xE63E)).PopAll
End Sub

Sub Rdb_Bluetooth_CheckedChange(Checked As Boolean)
	'Lbl_type_connexion.Text=cs.Initialize.Typeface(Typeface.MATERIALICONS).Color(0xFF01FF20).Size(40).Append(Chr(0xE1AA)).PopAll
End Sub

Sub SeekBar_Temp_cons_ValueChanged (Value As Int, UserChanged As Boolean)
	
	If Value<10 Then
		Lbl_Temp.Text="10°C"
		Lbl_Temp.RequestFocus
		C_temp=10
	Else
		Lbl_Temp.Text=Value & "°C"
		C_temp=Value
	End If
	
End Sub

Sub Btn_save_sensor_Click
	SeekBar_Temp_cons.Enabled=False
	Txt_Local_sensor.Enabled=False
	Btn_modif_sensor.Text= cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFF000000).Size(25).Append(Chr(0xF023)).PopAll
	actif_save=True
	Dim index_remove As Int
	
	For Each data As String In Main.list_Read_Setup 'Met à jour les données setup en mémoire
		Dim data_setup() As String =Regex.Split(";", data)
		If data_setup(2)=Cockpit.Macaddress Then
			
			If Remove_Sensor=True Then 'Supprime le sensor du Setup
				index_remove= Main.list_Read_Setup.IndexOf(data)
				Exit
			Else
				SeekBar_Temp_cons.Enabled=False 'ENregistre les nouveaux paramètres
				If data_setup.Length=4 Then
					Dim new_data As String= data_setup(0) & ";" & Txt_Local_sensor.text & ";" & data_setup(2) & ";" & C_temp
				Else If data_setup.Length=6 Then
					Dim new_data As String= data_setup(0) & ";" & Txt_Local_sensor.text & ";" & data_setup(2) & ";" & C_temp & ";" & data_setup(4) & ";" & data_setup(5)
				End If
				
				Log(Main.list_Read_Setup.IndexOf(data))
				Main.list_Read_Setup.Set(Main.list_Read_Setup.IndexOf(data),new_data)
			End If
			
		End If
	Next
	
	If Remove_Sensor=True Then 'Supprime le sensor du Setup
		Main.list_Read_setup.RemoveAt(index_remove)
		Btn_trash.Text= cs.Initialize.Typeface(Typeface.FONTAWESOME).Size(25).Append(Chr(0xF1F8)).PopAll
		Btn_save_sensor.Enabled=False
		Btn_trash.Visible=False
	End If
	
		
	wait for (Param.write_file_setup(Main.list_Read_Setup, file_Setup,False,False)) complete (result As Boolean)
	
	If IsPaused(Transfert_Server)=True Then
		'Lbl_info_transfert.Visible=True
		Main.type_transfert=Cockpit.Upload_File_HH
		StartService(Transfert_Server)
	End If
	
	
End Sub

Sub result_transfert_upload(success As Boolean)
	
	If Save_Power_Param=False Then
		 ' acknowledged Save sensor parameter
		If success=False Then
			Btn_save_sensor.TextColor=Colors.Red
		Else
			Btn_save_sensor.TextColor=Colors.Yellow
			'File.Delete(File.DirDefaultExternal, file_Setup) 'supprime le fichier local
			Btn_save_sensor.Enabled=False
		
		
			' lance une commande de lecture avec les nouveaux paramètres
		
			file_Setup= Main.Localisation_Home & "_" & "command.txt"
			Action_Command=True
			actif_save=False
			wait for (Param.write_file_setup(Main.list_Read_Setup, file_Setup,False,False)) complete (result As Boolean)
			Sleep(2000)
		
			If IsPaused(Transfert_Server)=True Then
				'Lbl_info_transfert.Visible=True
				Main.type_transfert=Cockpit.Upload_File_HH
				StartService(Transfert_Server)
			End If
		End If
	
		file_Setup=Main.Localisation_Home & "_" & "setup.txt"
		Btn_save_sensor.TextColor=Colors.Green
		Update_data_sensor_enable=True 'Provoque la vérif sur le serveur toutes les 10s
		Cockpit.Timer1.Enabled=True
	
		If Cockpit.Timer2.Enabled=False Then 'Active l'icone de contrôle de nouvelles données sur le serveur
			Cockpit.Timer2.Enabled=True
		End If
		
	Else 'acknowledged save Power parameter
		Lbl_info.Enabled=True
		If success=False Then
			Lbl_info.Text="Erreur de sauvegarde" & Chr(13) & Chr(10) & "Cliquez ICI pour réessayer" 
			Save_Power_Param=False
		Else
			
			Lbl_info.Text= "La prise est identifiée"
			Btn_conso.Visible=True 'Affichage de l'écran de contrôle de la prise connecté
			Save_Power_Param=False
		End If
		
	End If
	
	
End Sub

Sub Btn_modif_sensor_Click
	SeekBar_Temp_cons.Enabled=True
	Txt_Local_sensor.Enabled=True
	Btn_modif_sensor.Text= cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFF000000).Size(25).Append(Chr(0xF09C)).PopAll
	Btn_trash.Text= cs.Initialize.Typeface(Typeface.FONTAWESOME).Size(25).Append(Chr(0xF1F8)).PopAll
	Btn_save_sensor.Enabled=True
	Btn_trash.Visible=True
End Sub

Sub Btn_trash_Click
	
	Dim sf As Object = Xui.Msgbox2Async("Etes-vous sûr de vouloir supprimer cette sonde ?","Suppression Sonde","Oui","Non","",Null)
	
	Wait For (sf) Msgbox_Result (Result As Int)
	If Result = Xui.DialogResponse_Positive Then
		Btn_trash.Text= cs.Initialize.Typeface(Typeface.FONTAWESOME).Color(0xFFFF0000).Size(25).Append(Chr(0xF1F8)).PopAll
		Remove_Sensor=True
		Btn_save_sensor_Click
	End If
		
End Sub

Sub RadioButton1_CheckedChange(Checked As Boolean)
	
End Sub

Sub Rdb_thermo_CheckedChange(Checked As Boolean)
	
End Sub

Sub Lbl_add_equip_Click
	
	' affiche la liste des power compatible
	ImageSlider1.visible=True
	ImageSlider1.active_view
	ImageSlider1.nextImage
	Lbl_type_cx.Visible=True
	Panel_power.Visible=False
	
	Product_Type
End Sub

Public Sub Product_Type
	
	'Affiche le type de connexion sur l'image
	Select Case Type_power
		Case HS110
			Lbl_type_cx.Text=cs.Initialize.Typeface(Typeface.MATERIALICONS).Color(0xFF19FF00).Size(60).Append(Chr(0xE63E)).PopAll
			Rdb_wifi.Checked=True
			Rdb_wifi.Enabled=True
			Rdb_Bluetooth.Enabled=False
			Rdb_thermo.Enabled=False
		Case Beewi
			Lbl_type_cx.Text=cs.Initialize.Typeface(Typeface.MATERIALICONS).Color(0xFF0086FF).Size(60).Append(Chr(0xE60F)).PopAll
			Rdb_Bluetooth.Checked=True
			Rdb_Bluetooth.Enabled=True
			Rdb_wifi.Enabled=False
			Rdb_thermo.Enabled=False
		Case Thermo
			Lbl_type_cx.Text=cs.Initialize.Typeface(Typeface.MATERIALICONS).Color(0xFF0086FF).Size(60).Append(Chr(0xE60F)).PopAll
			Rdb_thermo.Checked=True
			Rdb_thermo.Enabled=True
			Rdb_wifi.Enabled=False
			Rdb_Bluetooth.Enabled=False
	End Select
	
End Sub

Sub ImageSlider1_GetImage (Index As Int) As ResumableSub
	' Charge les image dans le pictureView
	Return Xui.LoadBitmapResize(File.DirAssets, $"power${Index + 1}.png"$, _
    ImageSlider1.WindowBase.Width, ImageSlider1.WindowBase.Height, True)
	
End Sub

public Sub power_selected(index As Int)
	
	If Lbl_valid_power.Visible=True Then
		If index=-1 Then
			Lbl_valid_power.Visible=False
		Else
			Lbl_valid_power.Text=cs.Initialize.Typeface(Typeface.MATERIALICONS).Color(0xFF17CA04).Size(60).Append(Chr(0xE877)).PopAll
			Sleep(1000)
			Panel_power.Visible=True 'Selection de la prise
		End If
	Else if index<>-1 Then
		Lbl_valid_power.Visible=True
	End If
	
	
End Sub
Sub Lbl_info_Click
	'Paired=False
	If Save_Power_Param=False Then
		
		If Paired=False Then
		
			If Lbl_info.Text<>" Identification de la prise en cours..." Then
				myWifi.connectWifiAP(Scan_Power.Network_Local) 'Reconnexion sur le réseau lan de référence
				Lbl_info.Text="Attente réseau..." & Chr(13) & Chr(10) & "Veuillez patienter"
		
				Do While myWifi.WifiSSID <> Scan_Power.Network_Local
					Sleep(0)
				Loop
		
				Lbl_info.Text=" Identification de la prise en cours..."
		
				wait for (ping_device) complete  (result As Boolean) 'Recherche de l'Ip sur le réseau Local
			
				ProgressBar1.Visible=False
				Lbl_info.TextSize=14
				Lbl_info.SetTextAlignment("TOP","CENTER")
		
						
				If result=True Then
					Lbl_info.Text= "Sauvegarde des informations en cours..."
					Save_Power_Parameter
					
				Else
					Lbl_info.Text= "Impossible de trouver la prise sur le réseau"
				End If
			
			Else
				stop_Ping=True
				Lbl_info.Text= "Arrêt de la recherche en cours..."
			End If
		
		End If
		
	Else 'relance suavegarde des paramètres de la prise si echec
		
		Lbl_info.Text= "Sauvegarde des informations en cours..."
		Save_Power_Parameter
			
	End If
	
	
	
End Sub

Sub Save_Power_Parameter
	
	Save_Power_Param=True
	'Recherche les paramètres du Sensor à associer avec  la prise
	For Each data As String In Main.list_Read_Setup 
		Dim data_setup() As String =Regex.Split(";", data)
		If data_setup(2)=Cockpit.Macaddress Then
			
			' Ajout ou met à jour les données			
			
			Dim new_data As String= data_setup(0) & ";" & data_setup(1) & ";" & data_setup(2) & ";" & data_setup(3) & ";" & Scan_Power.Mac_Address & ";" & Ip_Tplink & ";" & Type_power
			Log(Main.list_Read_Setup.IndexOf(data))
			Main.list_Read_Setup.Set(Main.list_Read_Setup.IndexOf(data),new_data)
						
		End If
	Next
	
	'Mise à jour du fichier  et Sauvegarde dans le Cloud
	wait for (Param.write_file_setup(Main.list_Read_Setup, file_Setup,False,False)) complete (result As Boolean)
	
	If IsPaused(Transfert_Server)=True Then
		'Lbl_info_transfert.Visible=True
		Main.type_transfert=Cockpit.Upload_File_HH
		StartService(Transfert_Server)
	End If
	
End Sub


Sub ping_device As ResumableSub
	
	Dim p As Phone
	Dim sb As StringBuilder
	Dim offset_scan As Int=0
	
	Dim find_Ip_device As Boolean=False
	sb.Initialize
	Ip_Tplink=""
	
	Dim stdout As StringBuilder
	stdout.Initialize
	Dim stderr As StringBuilder
	stderr.Initialize
	Dim Offset As Int=1
	Dim Offset2 As Int=25
	ProgressBar1.Visible=True
	
	Try
		Do While Ip_Tplink="" Or Offset<254 'Scan le réseau local pour trouver l'ip du device
			
			Do While myWifi.WifiSSID <> Scan_Power.Network_Local
				Sleep(0)
			Loop
			Sleep(4000)
			
			sb.Initialize
			For offset_scan = Offset To Offset2
				ProgressBar1.Progress=offset_scan/2
				
				p.Shell("ping -c1 -w1 192.168.0." & offset_scan ,Null,sb,Null)
				
				Sleep(0)
				If stop_Ping=True Then 'Sort de la boucle si demande annulation
					Offset2	=254
					Lbl_info.Text= "Recherche stoppée"
					stop_Ping=False
					ProgressBar1.Visible=False
					Exit
				End If
			Next
			
			If sb.Length <>0 Then 'Change de rank si device non trouvé
				Offset=Offset2
				Offset2=Offset2+25
				If Offset2>254 Then
					Offset2	=254
				End If
			End If
			
			
			
			p.Shell("cat", Array As String("/proc/net/arp"), stdout, stderr)
			Dim list1() As String= Regex.Split(Chr(10),stdout)
						
			For Each data As String In list1
				Dim list2() As String=Regex.Split("    ",data)
				If list2(5).trim=Scan_Power.Mac_Address Then 'Extraction de l'Ip si Adresse Mac trouvée
					Ip_Tplink=list2(0).Trim
					
					If Ip_Tplink<>"192.168.0.1" Then 'Adresse hotspot du tplink
						Log("Ip Device= " & Ip_Tplink)
						find_Ip_device=True
						Return True
						'Exit
						Log(list2(0).Trim & ";" & list2(5).Trim)
					End If
					
				End If
			Next
'			If find_Ip_device=True Then
'				Return True
'				'Exit
'			End If
		Loop
	Catch
		
	End Try
	
	Return False
	
End Sub

Sub test_conso_device
	'test_device=True
	' Appel de la fonction envoi de la requête de commande
	If TPL_Echange.connected=False Then
		CallSub2(TPL_Echange, "ConnectToServer",Ip_Tplink) 'Connexion sur la prise et envoi de la commande
		Sleep(2000)
	End If
	CallSubDelayed(Scan_Power,"state_connexion")
End Sub

Sub Btn_conso_Click
		' Appel Routine envoi de la trame sur le device
	Btn_conso.Visible=False
	Panel_power.Visible=False
	Pnl_test_conso.Visible=True
	test_device=True
	Scan_Power.Network= Chr(34) & "emeter" & Chr(34)  & Chr(58) & Chr(123) & Chr(34) & "get_realtime" & Chr(34) & Chr(58) & Chr(123)  & Chr(125) & Chr(125) & Chr(125)
	
	CallSub2(TPL_Echange, "ConnectToServer",Ip_Tplink) 'Connexion sur la prise et envoi de la commande
	
End Sub

Sub Btn_quit_Click
	StopService(TPL_Echange)
	test_device=False
	Scan_Power.sending_data=False
	Lbl_info.Text= "La prise est maintenant associée au thermomètre."
	Panel_power.Visible=True
	Pnl_test_conso.Visible=False
	
	Paired=True
End Sub

Sub Btn_on_Click
	'test prise On
	test_device=True
	Test_OnOff=True
	Scan_Power.sending_data=False
	Scan_Power.Network= Chr(34) & "system" & Chr(34)  & Chr(58) & Chr(123) & Chr(34) & "set_relay_state" & Chr(34) & Chr(58) & Chr(123) & Chr(34) & "state"  & Chr(34) & Chr(58) & "1" & Chr(125) & Chr(125) & Chr(125)
	Btn_on.TextColor=0xFF139C00
	Btn_off.TextColor=0xFFFFFFFF
	If TPL_Echange.connected=False Then
		CallSub2(TPL_Echange, "ConnectToServer",Ip_Tplink) 'Connexion sur la  si deconnectée
		Sleep(1000)
		CallSubDelayed(Scan_Power,"state_connexion") 'envoi de la commande directement
	Else
		CallSubDelayed(Scan_Power,"state_connexion") 'envoi de la commande directement
	End If
End Sub
Sub Btn_off_Click
	'Test prise Off
	test_device=True
	Test_OnOff=True
	Scan_Power.sending_data=False
	Scan_Power.Network= Chr(34) & "system" & Chr(34)  & Chr(58) & Chr(123) & Chr(34) & "set_relay_state" & Chr(34) & Chr(58) & Chr(123) & Chr(34) & "state"  & Chr(34) & Chr(58) & "0" & Chr(125) & Chr(125) & Chr(125)
	Btn_off.TextColor=0xFF9C0000
	Btn_on.TextColor=0xFFFFFFFF
			
	If TPL_Echange.connected=False Then
		CallSub2(TPL_Echange, "ConnectToServer",Ip_Tplink) 'Connexion sur la  si deconnectée
		Sleep(1000)
		CallSubDelayed(Scan_Power,"state_connexion") 'envoi de la commande directement
	Else
		CallSubDelayed(Scan_Power,"state_connexion") 'envoi de la commande directement
	End If
		
End Sub

Sub Btn_restart_Click
	Btn_conso.Visible=False
	Panel_power.Visible=False
	Pnl_test_conso.Visible=True
	
	Scan_Power.Network= Chr(34) & "emeter" & Chr(34)  & Chr(58) & Chr(123) & Chr(34) & "get_realtime" & Chr(34) & Chr(58) & Chr(123)  & Chr(125) & Chr(125) & Chr(125)
	
	If test_device=False Then 'relance le test
		test_device=True
		Btn_restart.Text= cs.Initialize.Typeface(Typeface.MATERIALICONS).Color(0xFF139C00).Size(25).Append(Chr(0xE5D5)).PopAll
		If TPL_Echange.connected=False Then
			CallSub2(TPL_Echange, "ConnectToServer",Ip_Tplink) 'Connexion sur la  si deconnectée
			Sleep(2000)
			CallSubDelayed(Scan_Power,"state_connexion") 'envoi de la commande directement
		Else
			Scan_Power.sending_data=False
			CallSubDelayed(Scan_Power,"state_connexion") 'envoi de la commande directement
		End If
	Else 'stop le test
		Scan_Power.sending_data=False
		test_device=False
		Btn_restart.Text= cs.Initialize.Typeface(Typeface.MATERIALICONS).Color(0xFF9C0000).Size(25).Append(Chr(0xE5D5)).PopAll
	End If
	
	
End Sub



