﻿B4A=true
Group=Default Group
ModulesStructureVersion=1
Type=Service
Version=5.2
@EndOfDesignText@
#Region  Service Attributes 
	#StartAtBoot: False
	#ExcludeFromLibrary: True
#End Region

Sub Process_Globals
	Public manager As BleManager2
	Public currentStateText As String = "UNKNOWN"
	Public currentState As Int
	Public connected As Boolean = False
	Public ConnectedName As String
	Private ConnectedServices As List
	Public rp As RuntimePermissions
	Public bc As ByteConverter
	Public SharedFolder As String
	'Public scan_device As List
End Sub

Sub Service_Create
	manager.Initialize("manager")
	
	SharedFolder = rp.GetSafeDirDefaultExternal("shared")
End Sub

Sub Service_Start (StartingIntent As Intent)

End Sub

Public Sub ReadData
	For Each s As String In ConnectedServices
		manager.ReadData(s)
	Next
End Sub

Public Sub Disconnect
	manager.Disconnect
	Manager_Disconnected
End Sub

Sub Manager_StateChanged (State As Int)
	Select State
		Case manager.STATE_POWERED_OFF
			currentStateText = "POWERED OFF"
		Case manager.STATE_POWERED_ON
			currentStateText = "POWERED ON"
		Case manager.STATE_UNSUPPORTED
			currentStateText = "UNSUPPORTED"
	End Select
	currentState = State
	CallSub(Setup, "StateChanged")
End Sub

Sub Manager_DeviceFound (Name As String, Id As String, AdvertisingData As Map, RSSI As Double)
	
	Dim Id_sensor_found As Boolean=False
	
	Log("Found: " & Name & ", " & Id & ", RSSI = " & RSSI & ", " & AdvertisingData) 'ignore
	
	If Main.new_location=False  Then
		If Main.list_Read_Setup.Size<>0 Then
			Try
				For Each MACadress As String In Main.list_Read_Setup 'Enumere la liste des Macadress déjà enregistrées et les exclues de la recherche
					Dim Enum_Macadress() As String= Regex.Split(";",MACadress)
		
					If Name="MJ_HT_V1" Then 'filtre sur le model de sensor
					
						If Enum_Macadress(2)=Id Then
							Id_sensor_found=True
						End If
					
			
					End If
				Next
			Catch
				ToastMessageShow("Impossible de lire le fichier de configuration",True)
			End Try
			
			
			If Id_sensor_found=False And Name="MJ_HT_V1" Then
				CallSub3(Setup,"add_list_service",Name,Id & ";" & RSSI)
			End If
			

		Else
			
			If Name="MJ_HT_V1" Then 'filtre sur le model de sensor
						
				CallSub3(Setup,"add_list_service",Name,Id & ";" & RSSI)
			
			End If
			
		End If
			
	Else
		If Name="MJ_HT_V1" Then 'filtre sur le model de sensor
						
			CallSub3(Setup,"add_list_service",Name,Id & ";" & RSSI)
			
		End If
	End If
	
	
End Sub

public Sub StopScan
	manager.StopScan
End Sub

Public Sub StartScan
	If manager.State <> manager.STATE_POWERED_ON Then
		Log("Not powered on.")
	Else If rp.Check(rp.PERMISSION_ACCESS_COARSE_LOCATION) = False Then
		Log("No location permission.")
	Else
		manager.Scan2(Null, False)
	End If
End Sub

'Sub Manager_DataAvailable (ServiceId As String, Characteristics As Map)
'	CallSub3(Main, "DataAvailable", ServiceId, Characteristics)
'End Sub

Sub Manager_Disconnected
	Log("Disconnected")
	connected = False
	CallSub(Main, "StateChanged")
End Sub

Sub Manager_Connected (services As List)
	Log("Connected")
	connected = True
	ConnectedServices = services
	CallSub(Main, "StateChanged")
End Sub

'Return true to allow the OS default exceptions handler to handle the uncaught exception.
Sub Application_Error (Error As Exception, StackTrace As String) As Boolean
	Return True
End Sub

Sub Service_Destroy

End Sub
